#!/bin/sh

[ -z "${_EXEC%/}" ] && _EXEC="$(realpath "${0%/*}")" || _EXEC="${_EXEC%/}"
[ -z "${_DATA%/}" ] && _DATA=. || _DATA="${_DATA%/}"

file_pattern='^.*\.(mov|ts|mpg|mpeg|mp4|m4v|avi|mkv|flv|sfv|wmv|ogm|ogv|webm|iso|rmvb)$'

. "$_EXEC/cgilite/cgilite.sh"
. "$_EXEC/widgets.sh"

FILTER="$(GET f)"
SEARCH="$(GET s)"
ORDER="$(GET o |grep -m1 -xE 'Date|Name|Length' || printf Name)"
LISTSIZE="$(COOKIE pagesize |grep -m1 -xE '[1-9][0-9]*' || printf 50)"
ITEM="$(PATH "${PATH_INFO#/}")"

case $(GET a) in
  setprefs)
    SET_COOKIE +$((86400 * 90)) pagesize="$(POST pagesize |grep -m1 -xE '[1-9][0-9]*' || printf 50)"
    SET_COOKIE +$((86400 * 90))     mode="$(POST     mode |grep -m1 -xE 'browse|index' || printf browse)"
    SET_COOKIE +$((86400 * 90))  fakemp4="$(POST  fakemp4 |grep -m1 -xE 'yes' || printf no)"
    REDIRECT "$(POST ref)"
  ;;
esac

if [ "$ITEM" = "/style.css" ]; then
  . "$_EXEC/cgilite/file.sh"
  [ -r "$_DATA/$ITEM" ] && FILE "$_DATA/$ITEM" \
                        || FILE "$_EXEC/style.css"
elif [ -f "$_DATA/$ITEM" ]; then
  case $(GET a) in
    tag)
    ;;
    thumbnail)
      . "$_EXEC/cgilite/file.sh"
      index="$_DATA/${ITEM%/*}/.index"
      thumb="$index/${ITEM##*/}.jpg"
      [ -d "$index" -a \! -f "$thumb" ] \
      && file="$_DATA/$ITEM" . "$_EXEC/thumbnail.sh"
      FILE "$thumb"
    ;;
    delete)
    ;;
    *) . "$_EXEC/cgilite/file.sh"
      FILE "$_DATA/$ITEM"
    ;;
  esac
elif [ -d "$_DATA/$ITEM" ]; then
  case $(GET a) in
    spawnindex)
      if [ "$(POST recursive)" = yes ]; then
        find "$_DATA/$ITEM" -depth -type d \! -name .index \
                            -exec mkdir -p '{}'/.index \;
      else
        mkdir -p "$_DATA/$ITEM/.index"
      fi
      REDIRECT "$(POST ref)"
    ;;
    multitag)
    ;;
    *) . "$_EXEC/list.sh"
    ;;
  esac
else
  printf 'Status: 404 Not Found\r\nContent-Length 0:\r\n\r\n'
fi
